<?php

/**********************************************************************
**
** Classe de tlchargement de fichiers
**
** Fonctions : 
**      - cacher le vrai chemin du fichier
**      - renommer le fichier  tlcharger
**
** Auteur: Jihed Othmani /  <jihed.othmani@gmail.com>
**
***********************************************************************/

class FileDownloader{
    
    // juste un tableau pour regrouper les prprits du tlchargement
	
	// Le rpertoire contenant tous les fichiers est le suivant: . /serveur/stockage/
	
    private $properties = array("path" => "",       // le chemin rl du fichier
                                "name" => "",       // pour renommer le fichier
                                "type" => "",       // type du fichier
                                "size" => "",       // taille du fichier
                               );          

    // le constructeur
    public function __construct($path, $name=""){
        $name = ($name == "") ? substr(strrchr("/".$path,"/"),1) : $name; // si "name" n'est pas dfini, le fichier ne sera pas renomm

        $file_size = filesize($path);                                     // taille 
        $this->properties =  array(
                                    "path" => $path, 
                                    "name" => $name, 
                                    "type"=>$content_type, 
                                    "size" => $file_size, 
                                    );
    }
    
    // mthode publique pour commencer le tlchargement
    public function download_file(){
        if ( $this->properties['path'] == "" )                 // si le chemin n'est pas indiqu, erreur !
            echo '<reponse code="206"/>';
        
		else {
                   
		   // envoyer les enttes   
		   
		   // Dialogue de tlchargement
		    header("content-type: application/octet-stream");
            header('Content-Disposition: attachment; filename="'.$this->properties["name"].'";');
            header("Content-Transfer-Encoding: binary");                             // methode du transfert 
            header("Content-Length: ".$this->properties["size"]);                    // taille de tlchargement
            
            // envoyer le contenu du fichier   
			//echo("\ntaille: ".$this->properties["size"]);
			flush();
			readfile($this->properties["path"]);
				//echo "\nfin envoi";
        }
    }
}
?>