<?php
session_start();
require("cnx.php");
require("constantes.php");
require("fonctions_BDD.php");
require("fonctions_fichiers.php");

require "XmlGenerator.php";

class SimpleXMLElementExtended extends SimpleXMLElement{
public function getAttribute($name){
    $attrs = $this->attributes();
    return $attrs[$name];
}
public function getValeur(){
    $attrs = $this->attributes();
    return $attrs['value'];
}
}

$reponse = "<?xml version='1.0' standalone='yes'?>\n";

//------------------------------------------------------//

if(isset($_POST['batman'])) {

$objet = utf8_encode($_POST['batman']);
$objet = stripslashes($objet);

$xml = new SimpleXMLElementExtended($objet);

switch((string) $xml['action']) {
    case 'authentification':
        $code = setSession($xml->param[0]->getValeur(),$xml->param[1]->getValeur());
		if($code == OK) {
			$id = session_id();
			$idrep = $_SESSION['idRepGroupe'];
			$xmlgen = new XmlGenerator();
			$xmlgen->xmlfile($idrep,$id);
			
			$reponse .= "<reponse code_retour=\"".OK."\" >\n";
			$reponse .= "	<param name=\"id_session\" value=\"$id\" />\n";
			$reponse .= "	<param name=\"url_xml\" value=\"http://fuse.credi-ong.org/serveur/temp/$id.xml\" />\n"; 
			$reponse .= "</reponse>";
		} else {
			$reponse .= "<reponse code_retour=\"$code\" />";
		}
        break;

	case 'arborescence':
		$id = session_id();
		$idrep = $_SESSION['idRepGroupe'];
			$xmlgen = new XmlGenerator();
			$xmlgen->xmlfile($idrep,$id);
			
			$reponse .= "<reponse code_retour=\"".OK."\" >\n";
			$reponse .= "	<param name=\"url_xml\" value=\"http://fuse.credi-ong.org/serveur/temp/$id.xml\" />\n"; 
			$reponse .= "</reponse>";
		break;

	case 'quota':
			$reponse .= "<reponse code_retour=\"".OK."\" >\n";
			$reponse .= "<param name=\"taille\" value=\"".getQuota($_SESSION['grp_user'])."\" />\n";
			$reponse .= "<param name=\"taille_max\" value=\"".getQuotaMax($_SESSION['grp_user'])."\" />\n";
			$reponse .= "</reponse>";
		break;

	case 'date':
			$reponse .= "<reponse code_retour=\"".OK."\" >\n";
			$reponse .= "<param name=\"date\" value=\"".getmDate()."\" />\n";
			$reponse .= "</reponse>";
		break;
	
	case 'creer_rep':
		
		if (aDroitEcritureRep($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[1]->getValeur())) {

			$id = creerDossier($xml->param[0]->getValeur(),$xml->param[1]->getValeur(),$xml->param[2]->getValeur(),$_SESSION['id_user'],$_SESSION['grp_user']);
			$reponse .= "<reponse code_retour=\"".OK."\" >\n";
			$reponse .= "<param name=\"id\" value=\"$id\" />\n";
			$reponse .= "<param name=\"date\" value=\"".date("Y-m-d H:i:s")."\" />\n";
			$reponse .= "</reponse>"; 
		} else {
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		}
		break;
		
	case 'supprimer_rep':

		if (aDroitEcritureRep($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[0]->getValeur())) {

			supprimerDossier($xml->param[0]->getValeur(), $_SESSION['grp_user']);
			$reponse .= "<reponse code_retour=\"".OK."\" />\n"; 
		} else {
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		}
		break;
		
	case 'deplacer_rep':
		
		if (aDroitEcritureRep($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[0]->getValeur()) && aDroitEcritureRep($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[1]->getValeur())) {

			deplacerDossier($xml->param[0]->getValeur(),$xml->param[1]->getValeur());
			$reponse .= "<reponse code_retour=\"".OK."\" />\n"; 
		} else {
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		}
		break;
		
	case 'taille_rep':
		$t = tailleDossier($xml->param[0]->getValeur());
		$reponse .= "<reponse code_retour=\"".OK."\" >\n"; 
		$reponse .= "	<param name=\"taille_rep\" value=\"$t\" />\n";
		$reponse .= "</reponse>";
		break;

	case 'modif_droits_rep':

		if (aDroitEcritureRep($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[0]->getValeur())) {

			modifDroitsDossiers($xml->param[0]->getValeur(),$xml->param[1]->getValeur());
			$reponse .= "<reponse code_retour=\"".OK."\" />\n"; 
		} else {
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		}
		break;
		
	case 'renommer_rep':

		if (aDroitEcritureRep($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[0]->getValeur())) {

			renommerDossier($xml->param[0]->getValeur(),$xml->param[1]->getValeur());
			$reponse .= "<reponse code_retour=\"".OK."\" />\n"; 
		} else {
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		}
		break;

	case 'chmodD':
		if(chmodD($_SESSION['id_user'],$xml->param[0]->getValeur(),$xml->param[1]->getValeur())){
			$reponse .= "<reponse code_retour=\"".OK."\" />\n";
		} else {
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		}
		break;

	case 'infoD':
		$r = infosDossier($xml->param[0]->getValeur());
		if(count($r)>1){
			$reponse .= "<reponse code_retour=\"".OK."\" >\n";
			$reponse .= "<param name=\"droits\" value=\"".$r['droits']."\" />\n";
			$reponse .= "<param name=\"derniere_modif\" value=\"".$r['derniere_modif']."\" />\n";
			$reponse .= "</reponse>";
		} else {
			$reponse .= "<reponse code_retour=\"".ENOENT."\" />\n"; 
		}
		break;	
/*---------------- FICHIERS ---------------------*/

	case 'chmodF':
		if(chmodF($_SESSION['id_user'],$xml->param[0]->getValeur(),$xml->param[1]->getValeur())){
			$reponse .= "<reponse code_retour=\"".OK."\" />\n";
		} else {
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		}
		break;

	case 'infoF':
		$r = infosFichier($xml->param[0]->getValeur());
		if(count($r)>1){
			$reponse .= "<reponse code_retour=\"".OK."\" >\n";
			$reponse .= "<param name=\"droits\" value=\"".$r['droits']."\" />\n";
			$reponse .= "<param name=\"taille\" value=\"".$r['taille']."\" />\n";
			$reponse .= "<param name=\"date_creation\" value=\"".$r['date_creation']."\" />\n";
			$reponse .= "<param name=\"derniere_modif\" value=\"".$r['derniere_modif']."\" />\n";
			$reponse .= "</reponse>";
		} else {
			$reponse .= "<reponse code_retour=\"".ENOENT."\" />\n"; 
		}
		break;	

	case 'renommer_fichier':

		if (aDroitEcritureFic($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[0]->getValeur())) {

			renommerFichier($xml->param[0]->getValeur(),$xml->param[1]->getValeur());
			$reponse .= "<reponse code_retour=\"".OK."\" />\n"; 
		} else {
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		}
		break;

	case 'deplacer_fichier':
		
		if (aDroitEcritureFic($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[0]->getValeur()) && aDroitEcritureRep($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[1]->getValeur())) {
		
			deplacerFichier($xml->param[0]->getValeur(),$xml->param[1]->getValeur());
			$reponse .= "<reponse code_retour=\"".OK."\" />\n"; 
		} else {
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		}
		break;

	case 'supprimer_fichier':

		if (aDroitEcritureFic($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[0]->getValeur())) {

			supprimerFichier($xml->param[0]->getValeur(),$_SESSION['grp_user']);			
			$reponse .= "<reponse code_retour=\"".OK."\" />\n"; 
			effacer($xml->param[0]->getValeur(),$_SESSION['grp_user']);
		} else {
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		}
		break;

	case 'touch':
		
		if (aDroitEcritureRep($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[1]->getValeur())) {
			if(fichierNonExistant($xml->param[0]->getValeur(),$xml->param[1]->getValeur())){
			$id = touchFile($xml->param[0]->getValeur(),$_SESSION['id_user'],$xml->param[1]->getValeur(),$xml->param[2]->getValeur(),$_SESSION['grp_user']);
			//unlockFichier($id);
			$reponse .= "<reponse code_retour=\"".OK."\" >\n";
			$reponse .= "<param name=\"id\" value=\"$id\" />\n";
			$reponse .= "<param name=\"date\" value=\"".date("Y-m-d H:i:s")."\" />\n";
			$reponse .= "</reponse>";
			}
			else $reponse .= "<reponse code_retour=\"".FILE_ALREADY_EXIST."\" />\n"; 
		}
		 else 
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		break;

	case 'modifier_fichier':
		
		if (aDroitEcritureFic($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[0]->getValeur())) {
			if(lockFichier($xml->param[0]->getValeur()))
				$reponse .= "<reponse code_retour=\"".OK."\" />\n"; 
			else
				$reponse .= "<reponse code_retour=\"".EBUSY."\" />\n";
		}
		 else 
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		break;


	case 'telecharger_fichier':
		if (aDroitLectureFic($_SESSION['id_user'],$_SESSION['grp_user'],$xml->param[0]->getValeur())) {
			if(lockFichier($xml->param[0]->getValeur())){
				$reponse .= "<reponse code_retour=\"".OK."\">\n"; 
				$reponse .= "	<param name=\"url_download\" value=\"http://fuse.credi-ong.org/serveur/dl.php?id=".$xml->param[0]->getValeur()."\" />\n"; 
				$reponse .= "</reponse>";
			}
			else
				$reponse .= "<reponse code_retour=\"".EBUSY."\" />\n";			
		}
		 else 
			$reponse .= "<reponse code_retour=\"".PERMISSION_DENIED."\" />\n"; 
		break;
	
	case 'derniereMAJfichier':
		$fic = infosFichier($xml->param[0]->getValeur());
		$reponse .= "<reponse code_retour=\"".OK."\">\n"; 
		$reponse .= "	<param name=\"date_maj\" value=\"".$fic['derniere_modif']."\" />\n"; 
		$reponse .= "</reponse>";
		break;

    }
	
	echo $reponse;	
}

?>